UVA 11920 - 0 s, 1 s and ? Marks(贪心)

2024-06-01 21:18
文章标签 贪心 uva marks 11920

本文主要是介绍UVA 11920 - 0 s, 1 s and ? Marks(贪心),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

  0 s, 1 s and ? Marks 

Given a string consisting of 01 and ? only, change all the ? to 0/1, so that the size of the largest group is minimized. A group is a substring that contains either all zeros or all ones.

Consider the following example:

0 1 1 ? 0 1 0 ? ? ?

We can replace the question marks (?) to get

0 1 1 0 0 1 0 1 0 0

The groups are (0) (1 1) (0 0) (1) (0) (1) (0 0) and the corresponding sizes are 1, 2, 2, 1, 1, 1, 2. That means the above replacement would give us a maximum group size of 2. In fact, of all the 24 possible replacements, we won't get any maximum group size that is smaller than 2.

Input 

The first line of input is an integer T ( T$ \le$5000) that indicates the number of test cases. Each case is a line consisting of a string that contains 01 and ? only. The length of the string will be in the range [1,1000].

Output 

For each case, output the case number first followed by the size of the minimized largest group.

Sample Input 

4
011?010???
???
000111
00000000000000

Sample Output 

Case 1: 2
Case 2: 1
Case 3: 3
Case 4: 14

题意:给定一个串有0,1,?。?可以变成0或1,要求构造出一个串,使得连续的0,1的最大值最小。

思路:贪心,把连续的0,1,?保存在一起,然后去判断,如果是0,1就直接算最大值,如果是?,就看前面和后面是0还是1,如果前后相同且?个数为奇数或前后不同?个数为偶数,那么肯定可以交替01是最小的,反之,就看前面一串多1还是后面一串多1或者中间串多1比较好,注意如果中间只有一个?,那么就不用考虑中间多1的情况。

代码:

#include <stdio.h>
#include <string.h>
#define max(a,b) (a)>(b)?(a):(b)
const int N = 1005;int t, pn;
char str[N];
struct Point{int v, num;
} p[N];void init() {scanf("%s", str);memset(p, 0, sizeof(p));int len = strlen(str); pn = 0;char c = '#';for (int i = 0; i < len; i++) {if (str[i] == c) {p[pn - 1].num++;}else {c = str[i];p[pn].v = str[i] - '0';p[pn++].num++;}}
}int solve() {int ans = 1;for (int i = 0; i < pn; i++) {if (p[i].v == 0 || p[i].v == 1) {ans = max(ans, p[i].num);}else {if (ans >= 2 && p[i].num != 1) continue;if (i == 0 || i == pn - 1) continue;if (p[i - 1].v == p[i + 1].v && p[i].num % 2) continue;if (p[i - 1].v != p[i + 1].v && p[i].num % 2 == 0) continue;if (p[i - 1].num <= p[i + 1].num) {p[i - 1].num++;ans = max(ans, p[i - 1].num);}else {p[i + 1].num++;ans = max(ans, p[i + 1].num);	}}}return ans;
}int main() {int cas = 0;scanf("%d", &t);while (t--) {init();printf("Case %d: %d\n", ++cas, solve());}return 0;
}


这篇关于UVA 11920 - 0 s, 1 s and ? Marks(贪心)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1022137

相关文章

usaco 1.3 Barn Repair(贪心)

思路:用上M块木板时有 M-1 个间隙。目标是让总间隙最大。将相邻两个有牛的牛棚之间间隔的牛棚数排序,选取最大的M-1个作为间隙,其余地方用木板盖住。 做法: 1.若,板(M) 的数目大于或等于 牛棚中有牛的数目(C),则 目测 给每个牛牛发一个板就为最小的需求~ 2.否则,先对 牛牛们的门牌号排序,然后 用一个数组 blank[ ] 记录两门牌号之间的距离,然后 用数组 an

uva 10055 uva 10071 uva 10300(水题两三道)

情歌两三首,水题两三道。 好久没敲代码了为暑假大作战热热身。 uva 10055 Hashmat the Brave Warrior 求俩数相减。 两个debug的地方,一个是longlong,一个是输入顺序。 代码: #include<stdio.h>int main(){long long a, b;//debugwhile(scanf("%lld%lld", &

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

uva 10387 Billiard(简单几何)

题意是一个球从矩形的中点出发,告诉你小球与矩形两条边的碰撞次数与小球回到原点的时间,求小球出发时的角度和小球的速度。 简单的几何问题,小球每与竖边碰撞一次,向右扩展一个相同的矩形;每与横边碰撞一次,向上扩展一个相同的矩形。 可以发现,扩展矩形的路径和在当前矩形中的每一段路径相同,当小球回到出发点时,一条直线的路径刚好经过最后一个扩展矩形的中心点。 最后扩展的路径和横边竖边恰好组成一个直

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

uva 568 Just the Facts(n!打表递推)

题意是求n!的末尾第一个不为0的数字。 不用大数,特别的处理。 代码: #include <stdio.h>const int maxn = 10000 + 1;int f[maxn];int main(){#ifdef LOCALfreopen("in.txt", "r", stdin);#endif // LOCALf[0] = 1;for (int i = 1; i <=

uva 575 Skew Binary(位运算)

求第一个以(2^(k+1)-1)为进制的数。 数据不大,可以直接搞。 代码: #include <stdio.h>#include <string.h>const int maxn = 100 + 5;int main(){char num[maxn];while (scanf("%s", num) == 1){if (num[0] == '0')break;int len =

uva 10014 Simple calculations(数学推导)

直接按照题意来推导最后的结果就行了。 开始的时候只做到了第一个推导,第二次没有继续下去。 代码: #include<stdio.h>int main(){int T, n, i;double a, aa, sum, temp, ans;scanf("%d", &T);while(T--){scanf("%d", &n);scanf("%lf", &first);scanf

uva 10916 Factstone Benchmark(打表)

题意是求 k ! <= 2 ^ n ,的最小k。 由于n比较大,大到 2 ^ 20 次方,所以 2 ^ 2 ^ 20比较难算,所以做一些基础的数学变换。 对不等式两边同时取log2,得: log2(k ! ) <=  log2(2 ^ n)= n,即:log2(1) + log2(2) + log2 (3) + log2(4) + ... + log2(k) <= n ,其中 n 为 2 ^